// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.17.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.Compute.Fluent.Models
{
    using System.Linq;

    /// <summary>
    /// Describes a Virtual Machine Scale Set.
    /// </summary>
    [Microsoft.Rest.Serialization.JsonTransformation]
    public partial class VirtualMachineScaleSetInner : Microsoft.Azure.Management.Resource.Fluent.Resource
    {
        /// <summary>
        /// Initializes a new instance of the VirtualMachineScaleSetInner
        /// class.
        /// </summary>
        public VirtualMachineScaleSetInner() { }

        /// <summary>
        /// Initializes a new instance of the VirtualMachineScaleSetInner
        /// class.
        /// </summary>
        /// <param name="sku">the virtual machine scale set sku.</param>
        /// <param name="upgradePolicy">the upgrade policy.</param>
        /// <param name="virtualMachineProfile">the virtual machine
        /// profile.</param>
        /// <param name="provisioningState">the provisioning state, which only
        /// appears in the response.</param>
        /// <param name="overProvision">Specifies whether the Virtual Machine
        /// Scale Set should be overprovisioned.</param>
        public VirtualMachineScaleSetInner(string location = default(string), string id = default(string), string name = default(string), string type = default(string), System.Collections.Generic.IDictionary<string, string> tags = default(System.Collections.Generic.IDictionary<string, string>), Sku sku = default(Sku), UpgradePolicy upgradePolicy = default(UpgradePolicy), VirtualMachineScaleSetVMProfile virtualMachineProfile = default(VirtualMachineScaleSetVMProfile), string provisioningState = default(string), bool? overProvision = default(bool?))
            : base(location, id, name, type, tags)
        {
            Sku = sku;
            UpgradePolicy = upgradePolicy;
            VirtualMachineProfile = virtualMachineProfile;
            ProvisioningState = provisioningState;
            OverProvision = overProvision;
        }

        /// <summary>
        /// Gets or sets the virtual machine scale set sku.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "sku")]
        public Sku Sku { get; set; }

        /// <summary>
        /// Gets or sets the upgrade policy.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "properties.upgradePolicy")]
        public UpgradePolicy UpgradePolicy { get; set; }

        /// <summary>
        /// Gets or sets the virtual machine profile.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "properties.virtualMachineProfile")]
        public VirtualMachineScaleSetVMProfile VirtualMachineProfile { get; set; }

        /// <summary>
        /// Gets the provisioning state, which only appears in the response.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "properties.provisioningState")]
        public string ProvisioningState { get; private set; }

        /// <summary>
        /// Gets or sets specifies whether the Virtual Machine Scale Set
        /// should be overprovisioned.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "properties.overProvision")]
        public bool? OverProvision { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="Microsoft.Rest.ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public override void Validate()
        {
            if (this.VirtualMachineProfile != null)
            {
                this.VirtualMachineProfile.Validate();
            }
        }
    }
}
