// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.17.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.Network.Fluent.Models
{
    using System.Linq;

    public partial class BgpSettings
    {
        /// <summary>
        /// Initializes a new instance of the BgpSettings class.
        /// </summary>
        public BgpSettings() { }

        /// <summary>
        /// Initializes a new instance of the BgpSettings class.
        /// </summary>
        /// <param name="asn">Gets or sets this BGP speaker's ASN</param>
        /// <param name="bgpPeeringAddress">Gets or sets the BGP peering
        /// address and BGP identifier of this BGP speaker</param>
        /// <param name="peerWeight">Gets or sets the weight added to routes
        /// learned from this BGP speaker</param>
        public BgpSettings(long? asn = default(long?), string bgpPeeringAddress = default(string), int? peerWeight = default(int?))
        {
            Asn = asn;
            BgpPeeringAddress = bgpPeeringAddress;
            PeerWeight = peerWeight;
        }

        /// <summary>
        /// Gets or sets this BGP speaker's ASN
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "asn")]
        public long? Asn { get; set; }

        /// <summary>
        /// Gets or sets the BGP peering address and BGP identifier of this
        /// BGP speaker
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "bgpPeeringAddress")]
        public string BgpPeeringAddress { get; set; }

        /// <summary>
        /// Gets or sets the weight added to routes learned from this BGP
        /// speaker
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "peerWeight")]
        public int? PeerWeight { get; set; }

    }
}
