// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.17.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.Network.Fluent.Models
{
    using System.Linq;

    /// <summary>
    /// VPN client root certificate of virtual network gateway
    /// </summary>
    [Microsoft.Rest.Serialization.JsonTransformation]
    public partial class VpnClientRootCertificateInner : Microsoft.Azure.Management.Resource.Fluent.SubResource
    {
        /// <summary>
        /// Initializes a new instance of the VpnClientRootCertificateInner
        /// class.
        /// </summary>
        public VpnClientRootCertificateInner() { }

        /// <summary>
        /// Initializes a new instance of the VpnClientRootCertificateInner
        /// class.
        /// </summary>
        /// <param name="publicCertData">Gets or sets the certificate public
        /// data</param>
        /// <param name="provisioningState">Gets provisioning state of the VPN
        /// client root certificate resource Updating/Deleting/Failed</param>
        /// <param name="name">Gets name of the resource that is unique within
        /// a resource group. This name can be used to access the
        /// resource</param>
        /// <param name="etag">A unique read-only string that changes whenever
        /// the resource is updated</param>
        public VpnClientRootCertificateInner(string id = default(string), string publicCertData = default(string), string provisioningState = default(string), string name = default(string), string etag = default(string))
            : base(id)
        {
            PublicCertData = publicCertData;
            ProvisioningState = provisioningState;
            Name = name;
            Etag = etag;
        }

        /// <summary>
        /// Gets or sets the certificate public data
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "properties.publicCertData")]
        public string PublicCertData { get; set; }

        /// <summary>
        /// Gets provisioning state of the VPN client root certificate
        /// resource Updating/Deleting/Failed
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "properties.provisioningState")]
        public string ProvisioningState { get; set; }

        /// <summary>
        /// Gets name of the resource that is unique within a resource group.
        /// This name can be used to access the resource
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "name")]
        public string Name { get; set; }

        /// <summary>
        /// Gets or sets a unique read-only string that changes whenever the
        /// resource is updated
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "etag")]
        public string Etag { get; set; }

    }
}
