// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.17.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.Redis.Fluent.Models
{
    using System.Linq;

    /// <summary>
    /// Parameters for redis export operation.
    /// </summary>
    public partial class ExportRDBParametersInner
    {
        /// <summary>
        /// Initializes a new instance of the ExportRDBParametersInner class.
        /// </summary>
        public ExportRDBParametersInner() { }

        /// <summary>
        /// Initializes a new instance of the ExportRDBParametersInner class.
        /// </summary>
        /// <param name="prefix">Prefix to use for exported files.</param>
        /// <param name="container">Container name to export to.</param>
        /// <param name="format">File format.</param>
        public ExportRDBParametersInner(string prefix, string container, string format = default(string))
        {
            Format = format;
            Prefix = prefix;
            Container = container;
        }

        /// <summary>
        /// Gets or sets file format.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "format")]
        public string Format { get; set; }

        /// <summary>
        /// Gets or sets prefix to use for exported files.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "prefix")]
        public string Prefix { get; set; }

        /// <summary>
        /// Gets or sets container name to export to.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "container")]
        public string Container { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="Microsoft.Rest.ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (Prefix == null)
            {
                throw new Microsoft.Rest.ValidationException(Microsoft.Rest.ValidationRules.CannotBeNull, "Prefix");
            }
            if (Container == null)
            {
                throw new Microsoft.Rest.ValidationException(Microsoft.Rest.ValidationRules.CannotBeNull, "Container");
            }
        }
    }
}
