// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.17.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.Resource.Fluent.Models
{
    using System.Linq;

    /// <summary>
    /// Resource type managed by the resource provider.
    /// </summary>
    public partial class ProviderResourceType
    {
        /// <summary>
        /// Initializes a new instance of the ProviderResourceType class.
        /// </summary>
        public ProviderResourceType() { }

        /// <summary>
        /// Initializes a new instance of the ProviderResourceType class.
        /// </summary>
        /// <param name="resourceType">The resource type.</param>
        /// <param name="locations">The collection of locations where this
        /// resource type can be created in.</param>
        /// <param name="aliases">The aliases that are supported by this
        /// resource type.</param>
        /// <param name="apiVersions">The api version.</param>
        /// <param name="properties">The properties.</param>
        public ProviderResourceType(string resourceType = default(string), System.Collections.Generic.IList<string> locations = default(System.Collections.Generic.IList<string>), System.Collections.Generic.IList<AliasType> aliases = default(System.Collections.Generic.IList<AliasType>), System.Collections.Generic.IList<string> apiVersions = default(System.Collections.Generic.IList<string>), System.Collections.Generic.IDictionary<string, string> properties = default(System.Collections.Generic.IDictionary<string, string>))
        {
            ResourceType = resourceType;
            Locations = locations;
            Aliases = aliases;
            ApiVersions = apiVersions;
            Properties = properties;
        }

        /// <summary>
        /// Gets or sets the resource type.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "resourceType")]
        public string ResourceType { get; set; }

        /// <summary>
        /// Gets or sets the collection of locations where this resource type
        /// can be created in.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "locations")]
        public System.Collections.Generic.IList<string> Locations { get; set; }

        /// <summary>
        /// Gets or sets the aliases that are supported by this resource type.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "aliases")]
        public System.Collections.Generic.IList<AliasType> Aliases { get; set; }

        /// <summary>
        /// Gets or sets the api version.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "apiVersions")]
        public System.Collections.Generic.IList<string> ApiVersions { get; set; }

        /// <summary>
        /// Gets or sets the properties.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "properties")]
        public System.Collections.Generic.IDictionary<string, string> Properties { get; set; }

    }
}
