// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.17.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.Resource.Fluent.Models
{
    using System.Linq;

    /// <summary>
    /// Subscription information.
    /// </summary>
    public partial class SubscriptionInner
    {
        /// <summary>
        /// Initializes a new instance of the SubscriptionInner class.
        /// </summary>
        public SubscriptionInner() { }

        /// <summary>
        /// Initializes a new instance of the SubscriptionInner class.
        /// </summary>
        /// <param name="id">Gets or sets the ID of the resource
        /// (/subscriptions/SubscriptionId).</param>
        /// <param name="subscriptionId">Gets or sets the subscription
        /// Id.</param>
        /// <param name="displayName">Gets or sets the subscription display
        /// name</param>
        /// <param name="state">Gets or sets the subscription state</param>
        /// <param name="subscriptionPolicies">Gets or sets the subscription
        /// policies.</param>
        public SubscriptionInner(string id = default(string), string subscriptionId = default(string), string displayName = default(string), string state = default(string), SubscriptionPolicies subscriptionPolicies = default(SubscriptionPolicies))
        {
            Id = id;
            SubscriptionId = subscriptionId;
            DisplayName = displayName;
            State = state;
            SubscriptionPolicies = subscriptionPolicies;
        }

        /// <summary>
        /// Gets or sets the ID of the resource
        /// (/subscriptions/SubscriptionId).
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "id")]
        public string Id { get; set; }

        /// <summary>
        /// Gets or sets the subscription Id.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "subscriptionId")]
        public string SubscriptionId { get; set; }

        /// <summary>
        /// Gets or sets the subscription display name
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "displayName")]
        public string DisplayName { get; set; }

        /// <summary>
        /// Gets or sets the subscription state
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "state")]
        public string State { get; set; }

        /// <summary>
        /// Gets or sets the subscription policies.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "subscriptionPolicies")]
        public SubscriptionPolicies SubscriptionPolicies { get; set; }

    }
}
